%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Task Force on Modern Heuristic Optimization Test Beds
% Working Group on Modern Heuristic Optimization
% Intelligent Systems Subcommittee
% Power System Analysis, Computing, and Economic Committee
% 
% 2017 Competition
% Evaluating the Performance of Modern Heuristic Optimizers on Smart Grid Operation Problems
% 
% 
% Test bed 1:
% Stochastic OPF based active-reactive power dispatch 
% 
% 
% This file is the same that the constraint_handling.m file of 2014
% constest, some of the codes of 2014 competition have been modified by
% Sergio Rivera (E-Mail: srriverar@unal.edu.co)
% 
% Application of Modern Heuristic Optimization Algorithms 
% for Solving Optimal Power Flow Problems
% by
% Sebastian Wildenhues (E-Mail: sebastian.wildenhues@uni-due.de)
% 14th February 2014
% 
% Incorporating static penalty constraint handling method.
%
% This routine is called subsequent to every function evaluation, 
% i.e. power flow calculation. It does not affect the calculations 
% done in test_bed_OPF.p, which calculates internally the fitness by
% using static penalty constraint handling method.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [f,g]=constraint_handling(o,g)
% You may use procedural information
% such as function evaluation counter
% proc.i_eval to dynamically adjust
% your constraint handling method.
global proc
global ps
global ff
% Uniform penalty coefficient.
penalty=1;
% Sum up all violations.
% Note that, at this point, constraint
% vector g consists only of elements
% >=0 due to g(g<1e-4)=0 as internal
% preliminary step.

[ ~, y_size ] = size( g );
tmp_index = y_size - 2 * ps.n_gen_VS;

g_slack = g( 1 );
g_v = sum( g( 2 : 1 + 2 * ps.n_load ) );
g_MVA = sum( g( 1 + 2 * ps.n_load + 1 : tmp_index ) );
g_MVAR = sum( g( tmp_index + 1 : y_size ) );

% g_slack = ( g( 1 ) / 100 ) * ( g( 1 ) / 100 );
% g_v = sum( g( 2 : 1 + 2 * ps.n_load ) .* g( 2 : 1 + 2 * ps.n_load ) );
% g_MVA = sum( ( g( 1 + 2 * ps.n_load + 1 : tmp_index ) / 100 ) .* ( g( 1 + 2 * ps.n_load + 1 : tmp_index ) / 100 ) );
% g_MVAR = sum( ( g( tmp_index + 1 : y_size ) / 100 ) .* ( g( tmp_index + 1 : y_size ) / 100 ) );

% fprintf( '%.4f %.4f %.4f %.4f\n', g_slack, g_v, g_MVA, g_MVAR );
ff.i_sample = ff.i_sample + 1;
ff.weights( ff.i_sample, 1 ) = g_slack;
ff.weights( ff.i_sample, 2 ) = g_v;
ff.weights( ff.i_sample, 3 ) = g_MVA;
ff.weights( ff.i_sample, 4 ) = g_MVAR;

tmp = [ g_slack g_v g_MVA g_MVAR ] .* ff.coeff;
g = max( tmp );
% g = sum(g.*g);
% Fitness function.
f=o+penalty*g;
end